Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QUndoGroup

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QUndoGroup

All Implemented Interfaces:
  QtJambiInterface

    public class QUndoGroup

extends QObject

The `QUndoGroup` class is a group of `QUndoStack` objects. For an overview of the Qt's undo framework, see the overview.

An application often has multiple undo stacks, one for each opened document. At the same time, an application usually has one undo action and one redo action, which triggers undo or redo in the active document.

`QUndoGroup` is a group of `QUndoStack` objects, one of which may be active. It has an `undo()` and `redo()` slot, which calls `QUndoStack::undo()` and `QUndoStack::redo()` for the active stack. It also has the functions `createUndoAction()` and `createRedoAction()`. The actions returned by these functions behave in the same way as those returned by `QUndoStack::createUndoAction()` and `QUndoStack::createRedoAction()` of the active stack.

Stacks are added to a group with `addStack()` and removed with `removeStack()`. A stack is implicitly added to a group when it is created with the group as its parent `QObject`.

It is the programmer's responsibility to specify which stack is active by calling `QUndoStack::setActive()`, usually when the associated document window receives focus. The active stack may also be set with `setActiveStack()`, and is returned by `activeStack()`.

When a stack is added to a group using `addStack()`, the group does not take ownership of the stack. This means the stack has to be deleted separately from the group. When a stack is deleted, it is automatically removed from a group. A stack may belong to only one group. Adding it to another group will cause it to be removed from the previous group.

A `QUndoGroup` is also useful in conjunction with `QUndoView`. If a `QUndoView` is set to watch a group using `QUndoView::setGroup()`, it will update itself to display the active stack.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `activeStackChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `canRedoChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `canUndoChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `cleanChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `indexChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `redoTextChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `undoTextChanged` This signal takes 1 generic argument(s).

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QUndoGroup()` Creates an empty `QUndoGroup` object with parent `parent`.
`QUndoGroup(QObject parent)` Creates an empty `QUndoGroup` object with parent `parent`.

Method Summary
`QUndoStack` | `activeStack()` Returns the active stack of this group.
`void` | `addStack(QUndoStack stack)` Adds `stack` to this group.
`boolean` | `canRedo()` Returns the value of the active stack's `QUndoStack::canRedo()`.
`boolean` | `canUndo()` Returns the value of the active stack's `QUndoStack::canUndo()`.
`QAction` | `createRedoAction(QObject parent)` Creates an redo `QAction` object with parent `parent`.
`QAction` | `createRedoAction(QObject parent, java.lang.String prefix)` Creates an redo `QAction` object with parent `parent`.
`QAction` | `createUndoAction(QObject parent)` Creates an undo `QAction` object with parent `parent`.
`QAction` | `createUndoAction(QObject parent, java.lang.String prefix)` Creates an undo `QAction` object with parent `parent`.
`boolean` | `isClean()` Returns the value of the active stack's `QUndoStack::isClean()`.
`void` | `redo()` Calls `QUndoStack::redo()` on the active stack.
`java.lang.String` | `redoText()` Returns the value of the active stack's `QUndoStack::redoText()`.
`void` | `removeStack(QUndoStack stack)` Removes `stack` from this group.
`void` | `setActiveStack(QUndoStack stack)` Sets the active stack of this group to `stack`.
`java.util.List` | `stacks()` Returns a list of stacks in this group.
`void` | `undo()` Calls `QUndoStack::undo()` on the active stack.
`java.lang.String` | `undoText()` Returns the value of the active stack's `QUndoStack::undoText()`.

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### activeStackChanged

    public final QSignalEmitter.Signal1 activeStackChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.gui.QUndoStack(named: stack)>:

  This signal is emitted whenever the active stack of the group changes. This can happen when `setActiveStack()` or `QUndoStack::setActive()` is called, or when the active stack is removed form the group. `stack` is the new active stack. If no stack is active, `stack` is 0.

See also:
  `setActiveStack()`, and `QUndoStack::setActive()`.

### canRedoChanged

    public final QSignalEmitter.Signal1 canRedoChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: canRedo)>:

  This signal is emitted whenever the active stack emits `QUndoStack::canRedoChanged()` or the active stack changes.

  `canRedo` is the new state, or false if the active stack is 0.

See also:
  `QUndoStack::canRedoChanged()` , and `setActiveStack()`.

### canUndoChanged

    public final QSignalEmitter.Signal1 canUndoChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: canUndo)>:

  This signal is emitted whenever the active stack emits `QUndoStack::canUndoChanged()` or the active stack changes.

  `canUndo` is the new state, or false if the active stack is 0.

See also:
  `QUndoStack::canUndoChanged()` , and `setActiveStack()`.

### cleanChanged

    public final QSignalEmitter.Signal1 cleanChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: clean)>:

  This signal is emitted whenever the active stack emits `QUndoStack::cleanChanged()` or the active stack changes.

  `clean` is the new state, or true if the active stack is 0.

See also:
  `QUndoStack::cleanChanged()` , and `setActiveStack()`.

### indexChanged

    public final QSignalEmitter.Signal1 indexChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Integer(named: idx)>:

  This signal is emitted whenever the active stack emits `QUndoStack::indexChanged()` or the active stack changes.

  `idx` is the new current index, or 0 if the active stack is 0.

See also:
  `QUndoStack::indexChanged()` , and `setActiveStack()`.

### redoTextChanged

    public final QSignalEmitter.Signal1 redoTextChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.String(named: redoText)>:

  This signal is emitted whenever the active stack emits `QUndoStack::redoTextChanged()` or the active stack changes.

  `redoText` is the new state, or an empty string if the active stack is 0.

See also:
  `QUndoStack::redoTextChanged()` , and `setActiveStack()`.

### undoTextChanged

    public final QSignalEmitter.Signal1 undoTextChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.String(named: undoText)>:

  This signal is emitted whenever the active stack emits `QUndoStack::undoTextChanged()` or the active stack changes.

  `undoText` is the new state, or an empty string if the active stack is 0.

See also:
  `QUndoStack::undoTextChanged()` , and `setActiveStack()`.

Constructor Detail

### QUndoGroup

    public QUndoGroup()

  Creates an empty `QUndoGroup` object with parent `parent`.

See also:
  `addStack()`.

### QUndoGroup

    public QUndoGroup(QObject parent)

  Creates an empty `QUndoGroup` object with parent `parent`.

See also:
  `addStack()`.

Method Detail

### activeStack

    public final QUndoStack activeStack()

  Returns the active stack of this group.

  If none of the stacks are active, or if the group is empty, this function returns 0.

See also:
  `setActiveStack()`, and `QUndoStack::setActive()`.

### addStack

    public final void addStack(QUndoStack stack)

  Adds `stack` to this group. The group does not take ownership of the stack. Another way of adding a stack to a group is by specifying the group as the stack's parent `QObject` in QUndoStack::QUndoStack(). In this case, the stack is deleted when the group is deleted, in the usual manner of QObjects.

See also:
  `removeStack()`, `stacks()`, and QUndoStack::QUndoStack().

### canRedo

    public final boolean canRedo()

  Returns the value of the active stack's `QUndoStack::canRedo()`.

  If none of the stacks are active, or if the group is empty, this function returns false.

See also:
  `canUndo()`, and `setActiveStack()`.

### canUndo

    public final boolean canUndo()

  Returns the value of the active stack's `QUndoStack::canUndo()`.

  If none of the stacks are active, or if the group is empty, this function returns false.

See also:
  `canRedo()`, and `setActiveStack()`.

### createRedoAction

    public final QAction createRedoAction(QObject parent)

  Creates an redo `QAction` object with parent `parent`.

  Triggering this action will cause a call to `QUndoStack::redo()` on the active stack. The text of this action will always be the text of the command which will be redone in the next call to `redo()`, prefixed by `prefix`. If there is no command available for redo, if the group is empty or if none of the stacks are active, this action will be disabled.

  If `prefix` is empty, the default prefix "Undo" is used.

See also:
  `createUndoAction()`, `canRedo()`, and `QUndoCommand::text()`.

### createRedoAction

    public final QAction createRedoAction(QObject parent,
                                          java.lang.String prefix)

  Creates an redo `QAction` object with parent `parent`.

  Triggering this action will cause a call to `QUndoStack::redo()` on the active stack. The text of this action will always be the text of the command which will be redone in the next call to `redo()`, prefixed by `prefix`. If there is no command available for redo, if the group is empty or if none of the stacks are active, this action will be disabled.

  If `prefix` is empty, the default prefix "Undo" is used.

See also:
  `createUndoAction()`, `canRedo()`, and `QUndoCommand::text()`.

### createUndoAction

    public final QAction createUndoAction(QObject parent)

  Creates an undo `QAction` object with parent `parent`.

  Triggering this action will cause a call to `QUndoStack::undo()` on the active stack. The text of this action will always be the text of the command which will be undone in the next call to `undo()`, prefixed by `prefix`. If there is no command available for undo, if the group is empty or if none of the stacks are active, this action will be disabled.

  If `prefix` is empty, the default prefix "Undo" is used.

See also:
  `createRedoAction()`, `canUndo()`, and `QUndoCommand::text()`.

### createUndoAction

    public final QAction createUndoAction(QObject parent,
                                          java.lang.String prefix)

  Creates an undo `QAction` object with parent `parent`.

  Triggering this action will cause a call to `QUndoStack::undo()` on the active stack. The text of this action will always be the text of the command which will be undone in the next call to `undo()`, prefixed by `prefix`. If there is no command available for undo, if the group is empty or if none of the stacks are active, this action will be disabled.

  If `prefix` is empty, the default prefix "Undo" is used.

See also:
  `createRedoAction()`, `canUndo()`, and `QUndoCommand::text()`.

### isClean

    public final boolean isClean()

  Returns the value of the active stack's `QUndoStack::isClean()`.

  If none of the stacks are active, or if the group is empty, this function returns true.

See also:
  `setActiveStack()`.

### redo

    public final void redo()

  Calls `QUndoStack::redo()` on the active stack.

  If none of the stacks are active, or if the group is empty, this function does nothing.

See also:
  `undo()`, `canRedo()`, and `setActiveStack()`.

### redoText

    public final java.lang.String redoText()

  Returns the value of the active stack's `QUndoStack::redoText()`.

  If none of the stacks are active, or if the group is empty, this function returns an empty string.

See also:
  `undoText()`, and `setActiveStack()`.

### removeStack

    public final void removeStack(QUndoStack stack)

  Removes `stack` from this group. If the stack was the active stack in the group, the active stack becomes 0.

See also:
  `addStack()`, `stacks()`, and QUndoStack::~QUndoStack().

### setActiveStack

    public final void setActiveStack(QUndoStack stack)

  Sets the active stack of this group to `stack`.

  If the stack is not a member of this group, this function does nothing.

  Synonymous with calling `QUndoStack::setActive()` on `stack`.

  The actions returned by `createUndoAction()` and `createRedoAction()` will now behave in the same way as those returned by `stack`'s `QUndoStack::createUndoAction()` and `QUndoStack::createRedoAction()`.

See also:
  `QUndoStack::setActive()`, and `activeStack()`.

### stacks

    public final java.util.List stacks()

  Returns a list of stacks in this group.

See also:
  `addStack()`, and `removeStack()`.

### undo

    public final void undo()

  Calls `QUndoStack::undo()` on the active stack.

  If none of the stacks are active, or if the group is empty, this function does nothing.

See also:
  `redo()`, `canUndo()`, and `setActiveStack()`.

### undoText

    public final java.lang.String undoText()

  Returns the value of the active stack's `QUndoStack::undoText()`.

  If none of the stacks are active, or if the group is empty, this function returns an empty string.

See also:
  `redoText()`, and `setActiveStack()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD